# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports
from .lsp_ui import LSPUI


class LSPNotebook(Gtk.Notebook):
    def __init__(self):
        super(LSPNotebook, self).__init__()

        self._builder        = settings_manager.get_builder()
        self.lsp_config_data = settings_manager.get_lsp_config_data()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()
        
        self.show()


    def _setup_styling(self):
        self.set_tab_pos(Gtk.PositionType.LEFT)
        
        self.set_hexpand(True)
        self.set_vexpand(True)

        ctx = self.get_style_context()
        ctx.add_class("lsp-notebook")

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        for language, data in self.lsp_config_data.items():
            if "hidden" in data.keys() and data["hidden"]:
                continue

            tab_widget = Gtk.Label(label = language)
            lsp_ui     = LSPUI(language, data)

            self.append_page(lsp_ui, tab_widget)
            self.set_tab_detachable(lsp_ui, False)
            self.set_tab_reorderable(lsp_ui, False)