# Python imports

# Lib imports
import gi
gi.require_version('GtkSource', '4')
from gi.repository import GtkSource

# Application imports



# Request type formatting
# https://github.com/microsoft/multilspy/blob/main/src/multilspy/language_server.py#L417

content_part = """{
	"method": "textDocument/definition",
	"params": {
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    },
	    "position": {
	        "line": 5,
            "character": 12,
            "offset": 0
	    }
	}
}
"""

references_query = """{

    "method": "textDocument/references",
    "params": {
        "context": {
            "includeDeclaration": false
        },
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    },
	    "position": {
	        "line": 30,
            "character": 13,
            "offset": 0
	    }
	}
}
"""

symbols_query = """{
	"method": "textDocument/documentSymbol",
	"params": {
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    }
	}
}
"""



class LspMessageSourceView(GtkSource.View):
    def __init__(self):
        super(LspMessageSourceView, self).__init__()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        language_manager     = GtkSource.LanguageManager()
        style_scheme_manager = GtkSource.StyleSchemeManager()
        style_scheme         = style_scheme_manager.get_scheme("peacocks-in-space")
        style_scheme         = style_scheme if style_scheme else style_scheme_manager.get_scheme("solarized-dark")
        buffer               = self.get_buffer()
        ctx                  = self.get_style_context()

        self.set_vexpand(True)
        self.set_indent_width(4)
        self.set_tab_width(4)
        self.set_insert_spaces_instead_of_tabs(True)
        self.set_show_line_numbers(True)

        ctx.add_class("lsp-message-source-view")

        buffer.set_language( language_manager.get_language("json") )
        buffer.set_style_scheme(style_scheme)
        buffer.set_text(content_part)


    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        ...

    def get_text_str(self) -> str:
        buffer     = self.get_buffer()
        start, end = buffer.get_bounds()
        return buffer.get_text(start, end, True)